#ifndef MAIN_PRESENTER_HPP
#define MAIN_PRESENTER_HPP

#include <gui/model/ModelListener.hpp>
#include <mvp/Presenter.hpp>

using namespace touchgfx;

class mainView;

class mainPresenter : public Presenter, public ModelListener
{
public:
    mainPresenter(mainView& v);

    /**
     * The activate function is called automatically when this screen is "switched in"
     * (ie. made active). Initialization logic can be placed here.
     */
    virtual void activate();

    /**
     * The deactivate function is called automatically when this screen is "switched out"
     * (ie. made inactive). Teardown functionality can be placed here.
     */
    virtual void deactivate();

    void onCounterChanged(uint8_t nNewCounter);

    virtual ~mainPresenter() {};

private:
    mainPresenter();

    mainView& view;
};


#endif // MAIN_PRESENTER_HPP
